use std::{thread, sync::mpsc, time::Duration};

fn main() {
    let (tx, rx) = mpsc::channel();

    thread::spawn(move || {
        let vals = vec![
            String::from("h"),
            String::from("e"),
            String::from("l"),
            String::from("l"),
            String::from("o"),
        ];

        for v in vals {
            tx.send(v).unwrap();
            thread::sleep(Duration::from_millis(10));
        }
    });

    for received in rx {
        println!("received: {}", received);
    }
}
